using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ClipboardExample
{
   public partial class CustomerForm : Form, IClipboardSupport
   {
      List<BizObject.Customer> mDataSource = new List<BizObject.Customer>();
      
      public CustomerForm()
      {
         InitializeComponent();

         mDataSource.Add(new BizObject.Customer("", ""));
         this.customerBindingSource.DataSource = mDataSource;
         this.customerBindingSource.MoveFirst();
      }

      #region IClipboardSupport Members

      public void CopyData()
      {
         Clipboard.SetDataObject(BuildDataObject());
      }

      public void PasteData()
      {
         FillFromDataObject(Clipboard.GetDataObject());
      }

      private DataObject BuildDataObject()
      {
         DataObject dataObject = new DataObject();
         if (this.customerBindingSource.Current != null)
         {
            dataObject.SetData("CustomerFormat", this.customerBindingSource.Current);
            // To paste key information into another application like word
            dataObject.SetText(this.customerBindingSource.Current.ToString());
         }
         dataObject.SetData("CustomerListFormat", this.mDataSource);
         return dataObject;
      }

      private void FillFromDataObject(IDataObject dataObject)
      {
         if (dataObject.GetDataPresent("CustomerFormat"))
         {

            BizObject.Customer customer = dataObject.GetData("CustomerFormat") as BizObject.Customer;
            if (customer != null)
            {
               this.customerBindingSource.Add(customer);
               this.customerBindingSource.MoveLast();
            }
         }
      }

      #endregion
   }
}